<template>
  <div class="home">
    <HeaderComponent />
    <!-- Add movie section -->
    <div class="add_button_div">
      <button class="button" v-on:click="show_add_form">Ajouter un film</button>
    </div>
    <div class="add_movie" v-if="is_hide_adding">
      <div class="add_movie_column">
        <label>Titre</label>
        <input v-model="new_movie.title">
        <label>Date de sortie</label>
        <input v-model="new_movie.year" type="number">
        </div>
      <div class="add_movie_column">
        <label>Langue</label>
        <input v-model="new_movie.language">
        <label>Genre</label>
        <input v-model="new_movie.type">
      </div>
    </div>
    <div class="save_button_div">
      <img v-if="required_field" v-on:click="add_movie" src="../assets/add.png" style="cursor: pointer;">
    </div>
    <!-- search movie section -->
    <div class="search">
      <input class="search_bar" v-model="searchresult" placeholder="Rechercher (titre, année ou réalisateur)">
      <img id="search_button" v-on:click="search" src="../assets/search.svg" style="cursor: pointer;">
      <img id="close_button" v-on:click="close_search" v-if="searchresult" src="../assets/close.svg">
    </div>
    <!-- movies list -->
    <div class="movie_list">
      <div class="movie_item" v-for="item in home_list" :key="item.id">
        <MovieComponent :id="item.id" :title="item.title" :year="item.year" />
      </div>
    </div>
  </div>
</template>

<script>
// @ is an alias to /src
import HeaderComponent from '@/components/HeaderComponent.vue';
import MovieComponent from '@/components/MovieComponent.vue';

export default {
  name: 'HomeView',
  components: {
    HeaderComponent,
    MovieComponent
  },
  data() {
    return{
      movies_list: window.movies_list,
      home_list: [],
      searchresult: null,
      is_hide_adding: false,
      new_movie:{
        id: null,
        title: null,
        img:null,
        year: null ,
        language: null,
        realinfo: {name:'', nationality:'', birthdate:''},
        type: null,
        grade:null
      },
      number_of_movies: 0
    }
  },
  methods: {
    search: function(){
      if(this.searchresult == "" || this.searchresult == null){
        this.home_list = this.data_list;
      }
      else{
        this.home_list = this.home_list.filter(p => ((p.title.toLowerCase().includes(this.searchresult.toLowerCase()) || (p.year == parseInt(this.searchresult)) )));
      }
    },
    close_search: function(){
      this.searchresult = null;
      this.home_list = this.data_list;
    },
    add_movie: function(){
      for(this.i of this.data_list){
        if(this.i.id == this.number_of_movies + 1){
          this.number_of_movies += 1;
        }
      }
      this.new_movie.id = this.number_of_movies + 1;
      this.data_list.push(Object.assign({}, this.new_movie));
      this.home_list = this.data_list;
      this.new_movie.id = null;
      this.new_movie.title = null;
      this.new_movie.img = null;
      this.new_movie.year = null;
      this.new_movie.language = null;
      this.realinfo= {name:'', nationality:'', birthdate:''};
      this.new_movie.type = null;
      this.new_movie.grade = null;
      this.number_of_movies += 1;
    },
    show_add_form: function(){
      this.is_hide_adding = !this.is_hide_adding;
    }
  },
  computed: {
    required_field: function() {
      return this.new_movie.title && this.new_movie.year && this.new_movie.language && this.new_movie.type;
    }
  },
  mounted(){
    this.data_list = this.movies_list.movies;
    this.home_list = this.movies_list.movies;
    for (this.data_list_movies_title of this.data_list){
      this.number_of_movies += 1;
    }
  }
}
</script>

<style>
.home{
  background-color:#E9ECF1;
  width:50vw;
  margin-right:auto;
  margin-left:auto;
  min-height: 100vh;
}
.add_button_div{
  text-align:center;
  margin-bottom: 4vh;
}
.button{
  background-color: rgb(65,184,131);
  padding: 16px;
  border-radius: 30px;
  border:none;
  font-size: 1em;
  cursor: pointer;
  font-family: arial;
  font-weight: bold;
}
.button:hover{
  background-color: rgb(145,217,184);
  color:white;
}
.add_movie{
  display:flex;
  align-items: center;
  justify-content:center;
  margin-bottom: 3vh;
}
.add_movie_column{
  display:flex;
  flex-direction:column;
  align-items: center;
  justify-content:center;
}
.save_button_div{
  text-align:center;
  margin-bottom: 4vh;
}
.search{
  display: flex;
  align-items: center;
  justify-content:center;
  margin-bottom: 4vh;
  margin-top: 8vh;
}
.search_bar{
  height: 40px;
  width:300px;
  margin-bottom: 20px;
}
#search_button{
  height: 40px;
  margin-bottom: 20px;
}
#close_button {
  cursor: pointer;
  margin-bottom: 20px;
}
.movie_list{
  display:flex;
  align-items: center;
  justify-content:center;
  flex-direction: column;
  padding-bottom: 8vh;
  font-size: 0.9em;
  font-family: arial;
  font-weight: bold;
}
.movie_item{
  text-align:center;
  background-color: rgb(65,184,131);
  width: 60%;
  border-radius:10px;
  margin-top:4px;
  display:flex;
  justify-content:space-between;
  align-items:center;
  padding-left:30px;
  padding-right:20px;
}
.movie_item:hover{
  background-color:rgb(145,217,184);
}

@media screen and (max-width: 1650px){
  .home{
    width:800px;
  }
}

@media screen and (max-width: 800px){
  .home{
    width:100%;
  }
  .movie_item{
    width:80vw;
  }
}
</style>
